// Class: openfl._internal.renderer.BitmapDataPool

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

var $hxClasses = require("./../../../hxClasses_stub").default;
var $import = require("./../../../import_stub").default;
var $bind = require("./../../../bind_stub").default;
function HxOverrides() {return require("./../../../HxOverrides");}
function haxe_ds_IntMap() {return require("./../../../haxe/ds/IntMap");}
function lime_utils_ObjectPool() {return require("./../../../lime/utils/ObjectPool");}
function openfl_display_BitmapData() {return require("./../../../openfl/display/BitmapData");}
function haxe_ds_ObjectMap() {return require("./../../../haxe/ds/ObjectMap");}

// Constructor

var BitmapDataPool = function(lifetime,context3D) {
	if(lifetime == null) {
		lifetime = 2;
	}
	this.__lifetime = lifetime;
	this.__context = context3D;
	this.__bitmapData = new (haxe_ds_IntMap().default)();
	this.__bitmapDataAge = new (haxe_ds_ObjectMap().default)();
	this.__bitmapDataList = [];
}

// Meta

BitmapDataPool.__name__ = ["openfl","_internal","renderer","BitmapDataPool"];
BitmapDataPool.prototype = {
	cleanup: function() {
		var _g = 0;
		var _g1 = this.__bitmapDataList;
		while(_g < _g1.length) {
			var bitmapData = _g1[_g];
			++_g;
			var age = this.__bitmapDataAge.get(bitmapData);
			if(age >= this.__lifetime) {
				this.__bitmapData.get(bitmapData.width).get(bitmapData.height).remove(bitmapData);
				bitmapData.dispose();
				this.__bitmapDataAge.remove(bitmapData);
				(HxOverrides().default).remove(this.__bitmapDataList,bitmapData);
			} else if(age > -1) {
				var v = age + 1;
				this.__bitmapDataAge.set(bitmapData,v);
			}
		}
	},
	get: function(width,height) {
		var heightMap = this.__bitmapData.get(width);
		if(heightMap == null) {
			var this1 = this.__bitmapData;
			var v = new (haxe_ds_IntMap().default)();
			this1.set(width,v);
			heightMap = v;
		}
		var pool = heightMap.get(height);
		if(pool == null) {
			var f = $bind(this,this.__createBitmapData);
			var a1 = width;
			var a2 = height;
			var v1 = new (lime_utils_ObjectPool().default)(function() {
				return f(a1,a2);
			},$bind(this,this.__cleanBitmapData));
			heightMap.set(height,v1);
			pool = v1;
		}
		var bitmapData = pool.get();
		if(bitmapData == null) {
			return null;
		}
		if(!this.__bitmapDataAge.exists(bitmapData)) {
			this.__bitmapDataList.push(bitmapData);
		}
		this.__bitmapDataAge.set(bitmapData,-1);
		return bitmapData;
	},
	release: function(bitmapData) {
		if(this.__bitmapDataAge.exists(bitmapData)) {
			this.__bitmapData.get(bitmapData.width).get(bitmapData.height).release(bitmapData);
			this.__bitmapDataAge.set(bitmapData,0);
		}
	},
	__cleanBitmapData: function(bitmapData) {
		bitmapData.fillRect(bitmapData.rect,0);
	},
	__createBitmapData: function(width,height) {
		if(this.__context != null) {
			var texture = this.__context.createRectangleTexture(width,height,"bgra",true);
			var bitmapData = (openfl_display_BitmapData().default).fromTexture(texture);
			return bitmapData;
		} else {
			return new (openfl_display_BitmapData().default)(width,height,true,0);
		}
	}
};
BitmapDataPool.prototype.__class__ = BitmapDataPool.prototype.constructor = $hxClasses["openfl._internal.renderer.BitmapDataPool"] = BitmapDataPool;

// Init



// Statics




// Export

exports.default = BitmapDataPool;