// Class: openfl._internal.renderer.cairo.CairoRenderer

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

var $hxClasses = require("./../../../../hxClasses_stub").default;
var $import = require("./../../../../import_stub").default;
var $extend = require("./../../../../extend_stub").default;
function openfl_display_CairoRenderer() {return require("./../../../../openfl/display/CairoRenderer");}
function lime_graphics_cairo__$CairoSurface_CairoSurface_$Impl_$() {return require("./../../../../lime/graphics/cairo/_CairoSurface/CairoSurface_Impl_");}
function openfl__$internal_renderer_cairo_CairoBitmap() {return require("./../../../../openfl/_internal/renderer/cairo/CairoBitmap");}
function openfl__$internal_renderer_cairo_CairoDisplayObject() {return require("./../../../../openfl/_internal/renderer/cairo/CairoDisplayObject");}
function lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$() {return require("./../../../../lime/graphics/cairo/_CairoPattern/CairoPattern_Impl_");}
function Type() {return require("./../../../../Type");}
function openfl__$internal_renderer_cairo_CairoGraphics() {return require("./../../../../openfl/_internal/renderer/cairo/CairoGraphics");}
function openfl__$internal_renderer_cairo_CairoTextField() {return require("./../../../../openfl/_internal/renderer/cairo/CairoTextField");}
function openfl__$internal_renderer_cairo_CairoTilemap() {return require("./../../../../openfl/_internal/renderer/cairo/CairoTilemap");}
function openfl_geom_Matrix() {return require("./../../../../openfl/geom/Matrix");}
function openfl_geom_ColorTransform() {return require("./../../../../openfl/geom/ColorTransform");}
function openfl_geom_Rectangle() {return require("./../../../../openfl/geom/Rectangle");}
function openfl_display_BitmapData() {return require("./../../../../openfl/display/BitmapData");}
function openfl_display_Bitmap() {return require("./../../../../openfl/display/Bitmap");}
function lime_graphics_cairo_Cairo() {return require("./../../../../lime/graphics/cairo/Cairo");}
function js_Boot() {return require("./../../../../js/Boot");}
function openfl_geom_Point() {return require("./../../../../openfl/geom/Point");}
function lime_math_Matrix3() {return require("./../../../../lime/math/Matrix3");}

// Constructor

var CairoRenderer = function(cairo) {
	(openfl_display_CairoRenderer().default).call(this,cairo);
	this.__colorTransform = new (openfl_geom_ColorTransform().default)();
	this.__matrix = new (openfl_geom_Matrix().default)();
	this.__matrix3 = new (lime_math_Matrix3().default)();
	this.__type = "cairo";
}

// Meta

CairoRenderer.__name__ = ["openfl","_internal","renderer","cairo","CairoRenderer"];
CairoRenderer.__super__ = (openfl_display_CairoRenderer().default);
CairoRenderer.prototype = $extend((openfl_display_CairoRenderer().default).prototype, {
	applyMatrix: function(transform,cairo) {
		if(cairo == null) {
			cairo = this.cairo;
		}
		this.__matrix.copyFrom(transform);
		if(this.cairo == cairo && this.__worldTransform != null) {
			this.__matrix.concat(this.__worldTransform);
		}
		this.__matrix3.a = this.__matrix.a;
		this.__matrix3.b = this.__matrix.b;
		this.__matrix3.c = this.__matrix.c;
		this.__matrix3.d = this.__matrix.d;
		if(this.__roundPixels) {
			this.__matrix3.tx = Math.round(this.__matrix.tx);
			this.__matrix3.ty = Math.round(this.__matrix.ty);
		} else {
			this.__matrix3.tx = this.__matrix.tx;
			this.__matrix3.ty = this.__matrix.ty;
		}
		cairo.set_matrix(this.__matrix3);
	},
	__clear: function() {
		if(this.cairo == null) {
			return;
		}
		this.cairo.identityMatrix();
		if(this.__stage != null && this.__stage.__clearBeforeRender) {
			var cacheBlendMode = this.__blendMode;
			this.__setBlendMode("normal");
			this.cairo.setSourceRGB(this.__stage.__colorSplit[0],this.__stage.__colorSplit[1],this.__stage.__colorSplit[2]);
			this.cairo.paint();
			this.__setBlendMode(cacheBlendMode);
		}
	},
	__drawBitmapData: function(bitmapData,source,clipRect) {
		if(clipRect != null) {
			this.__pushMaskRect(clipRect,source.__renderTransform);
		}
		if(source == bitmapData) {
			source = bitmapData.clone();
		}
		if(!this.__allowSmoothing) {
			this.cairo.set_antialias(1);
		}
		this.__render(source);
		if(!this.__allowSmoothing) {
			this.cairo.set_antialias(5);
		}
		(lime_graphics_cairo__$CairoSurface_CairoSurface_$Impl_$().default).flush(this.cairo.get_target());
		bitmapData.image.dirty = true;
		bitmapData.image.version++;
		if(clipRect != null) {
			this.__popMaskRect();
		}
	},
	__getAlpha: function(value) {
		return value * this.__worldAlpha;
	},
	__getColorTransform: function(value) {
		if(this.__worldColorTransform != null) {
			this.__colorTransform.__copyFrom(this.__worldColorTransform);
			this.__colorTransform.__combine(value);
			return this.__colorTransform;
		} else {
			return value;
		}
	},
	__popMask: function() {
		this.cairo.restore();
	},
	__popMaskObject: function(object,handleScrollRect) {
		if(handleScrollRect == null) {
			handleScrollRect = true;
		}
		if(!object.__isCacheBitmapRender && object.__mask != null) {
			this.__popMask();
		}
		if(handleScrollRect && object.__scrollRect != null) {
			this.__popMaskRect();
		}
	},
	__popMaskRect: function() {
		this.cairo.restore();
	},
	__pushMask: function(mask) {
		this.cairo.save();
		this.applyMatrix(mask.__renderTransform,this.cairo);
		this.cairo.newPath();
		this.__renderMask(mask);
		this.cairo.clip();
	},
	__pushMaskObject: function(object,handleScrollRect) {
		if(handleScrollRect == null) {
			handleScrollRect = true;
		}
		if(handleScrollRect && object.__scrollRect != null) {
			this.__pushMaskRect(object.__scrollRect,object.__renderTransform);
		}
		if(!object.__isCacheBitmapRender && object.__mask != null) {
			this.__pushMask(object.__mask);
		}
	},
	__pushMaskRect: function(rect,transform) {
		this.cairo.save();
		this.applyMatrix(transform,this.cairo);
		this.cairo.newPath();
		this.cairo.rectangle(rect.x,rect.y,rect.width,rect.height);
		this.cairo.clip();
	},
	__render: function(object) {
		if(this.cairo == null) {
			return;
		}
		if(object != null) {
			if(object.__type != null) {
				this.__renderDisplayObject(object);
			} else {
				this.__renderBitmapData(object);
			}
		}
	},
	__renderBitmap: function(bitmap) {
		this.__updateCacheBitmap(bitmap,false);
		if(bitmap.__bitmapData != null && bitmap.__bitmapData.image != null) {
			bitmap.__imageVersion = bitmap.__bitmapData.image.version;
		}
		if(bitmap.__cacheBitmap != null && !bitmap.__isCacheBitmapRender) {
			(openfl__$internal_renderer_cairo_CairoBitmap().default).render(bitmap.__cacheBitmap,this);
		} else {
			(openfl__$internal_renderer_cairo_CairoDisplayObject().default).render(bitmap,this);
			(openfl__$internal_renderer_cairo_CairoBitmap().default).render(bitmap,this);
		}
	},
	__renderBitmapData: function(bitmapData) {
		if(!bitmapData.readable) {
			return;
		}
		this.applyMatrix(bitmapData.__renderTransform,this.cairo);
		var surface = bitmapData.getSurface();
		if(surface != null) {
			var pattern = (lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).createForSurface(surface);
			if(!this.__allowSmoothing || this.cairo.get_antialias() == 1) {
				(lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).set_filter(pattern,3);
			} else {
				(lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).set_filter(pattern,1);
			}
			this.cairo.set_source(pattern);
			this.cairo.paint();
		}
	},
	__renderDisplayObject: function(object) {
		if(object != null && object.__type != null) {
			var _g = object.__type;
			switch((Type().default).enumIndex(_g)) {
			case 0:
				this.__renderBitmap(object);
				break;
			case 2:
				this.__renderDisplayObjectContainer(object);
				break;
			case 1:case 4:
				this.__renderShape(object);
				break;
			case 5:
				this.__renderSimpleButton(object);
				break;
			case 6:
				this.__renderTextField(object);
				break;
			case 7:
				this.__renderTilemap(object);
				break;
			case 8:
				this.__renderVideo(object);
				break;
			default:
			}
			if(object.__customRenderEvent != null) {
				var event = object.__customRenderEvent;
				event.allowSmoothing = this.__allowSmoothing;
				event.objectMatrix.copyFrom(object.__renderTransform);
				event.objectColorTransform.__copyFrom(object.__worldColorTransform);
				event.renderer = this;
				event.type = "renderCairo";
				this.__setBlendMode(object.__worldBlendMode);
				this.__pushMaskObject(object);
				object.dispatchEvent(event);
				this.__popMaskObject(object);
			}
		}
	},
	__renderDisplayObjectContainer: function(container) {
		container.__cleanupRemovedChildren();
		if(!container.__renderable || container.__worldAlpha <= 0) {
			return;
		}
		this.__updateCacheBitmap(container,false);
		if(container.__cacheBitmap != null && !container.__isCacheBitmapRender) {
			(openfl__$internal_renderer_cairo_CairoBitmap().default).render(container.__cacheBitmap,this);
		} else {
			(openfl__$internal_renderer_cairo_CairoDisplayObject().default).render(container,this);
		}
		if(container.__cacheBitmap != null && !container.__isCacheBitmapRender) {
			return;
		}
		this.__pushMaskObject(container);
		if(this.__stage != null) {
			var _g = 0;
			var _g1 = container.__children;
			while(_g < _g1.length) {
				var child = _g1[_g];
				++_g;
				this.__renderDisplayObject(child);
				child.__renderDirty = false;
			}
			container.__renderDirty = false;
		} else {
			var _g2 = 0;
			var _g11 = container.__children;
			while(_g2 < _g11.length) {
				var child1 = _g11[_g2];
				++_g2;
				this.__renderDisplayObject(child1);
			}
		}
		this.__popMaskObject(container);
	},
	__renderMask: function(mask) {
		if(mask != null) {
			var _g = mask.__type;
			switch((Type().default).enumIndex(_g)) {
			case 0:
				this.cairo.rectangle(0,0,mask.get_width(),mask.get_height());
				break;
			case 2:
				var container = mask;
				container.__cleanupRemovedChildren();
				if(container.__graphics != null) {
					(openfl__$internal_renderer_cairo_CairoGraphics().default).renderMask(container.__graphics,this);
				}
				var _g1 = 0;
				var _g11 = container.__children;
				while(_g1 < _g11.length) {
					var child = _g11[_g1];
					++_g1;
					this.__renderMask(child);
				}
				break;
			case 3:
				break;
			case 5:
				var button = mask;
				this.__renderMask(button.__currentState);
				break;
			default:
				if(mask.__graphics != null) {
					(openfl__$internal_renderer_cairo_CairoGraphics().default).renderMask(mask.__graphics,this);
				}
			}
		}
	},
	__renderShape: function(shape) {
		this.__updateCacheBitmap(shape,false);
		if(shape.__cacheBitmap != null && !shape.__isCacheBitmapRender) {
			(openfl__$internal_renderer_cairo_CairoBitmap().default).render(shape.__cacheBitmap,this);
		} else {
			(openfl__$internal_renderer_cairo_CairoDisplayObject().default).render(shape,this);
		}
	},
	__renderSimpleButton: function(button) {
		if(!button.__renderable || button.__worldAlpha <= 0 || button.__currentState == null) {
			return;
		}
		this.__pushMaskObject(button);
		this.__renderDisplayObject(button.__currentState);
		this.__popMaskObject(button);
	},
	__renderTextField: function(textField) {
		this.__updateCacheBitmap(textField,false);
		if(textField.__cacheBitmap != null && !textField.__isCacheBitmapRender) {
			(openfl__$internal_renderer_cairo_CairoBitmap().default).render(textField.__cacheBitmap,this);
		} else {
			(openfl__$internal_renderer_cairo_CairoTextField().default).render(textField,this,textField.__worldTransform);
			(openfl__$internal_renderer_cairo_CairoDisplayObject().default).render(textField,this);
		}
	},
	__renderTilemap: function(tilemap) {
		this.__updateCacheBitmap(tilemap,false);
		if(tilemap.__cacheBitmap != null && !tilemap.__isCacheBitmapRender) {
			(openfl__$internal_renderer_cairo_CairoBitmap().default).render(tilemap.__cacheBitmap,this);
		} else {
			(openfl__$internal_renderer_cairo_CairoDisplayObject().default).render(tilemap,this);
			(openfl__$internal_renderer_cairo_CairoTilemap().default).render(tilemap,this);
		}
	},
	__renderVideo: function(video) {
	},
	__setBlendMode: function(value) {
		if(this.__overrideBlendMode != null) {
			value = this.__overrideBlendMode;
		}
		if(this.__blendMode == value) {
			return;
		}
		this.__blendMode = value;
		this.__setBlendModeCairo(this.cairo,value);
	},
	__setBlendModeCairo: function(cairo,value) {
		switch(value) {
		case "add":
			cairo.setOperator(12);
			break;
		case "darken":
			cairo.setOperator(17);
			break;
		case "difference":
			cairo.setOperator(23);
			break;
		case "hardlight":
			cairo.setOperator(21);
			break;
		case "layer":
			cairo.setOperator(2);
			break;
		case "lighten":
			cairo.setOperator(18);
			break;
		case "multiply":
			cairo.setOperator(14);
			break;
		case "overlay":
			cairo.setOperator(16);
			break;
		case "screen":
			cairo.setOperator(15);
			break;
		default:
			cairo.setOperator(2);
		}
	},
	__updateCacheBitmap: function(object,force) {
		if(object.__isCacheBitmapRender) {
			return false;
		}
		var updated = false;
		if(object.get_cacheAsBitmap() || !object.__worldColorTransform.__isDefault(true) || this.__worldColorTransform != null && !this.__worldColorTransform.__isDefault(true)) {
			if(object.__cacheBitmapMatrix == null) {
				object.__cacheBitmapMatrix = new (openfl_geom_Matrix().default)();
			}
			var hasFilters = object.__filters != null;
			var bitmapMatrix = object.__cacheAsBitmapMatrix != null ? object.__cacheAsBitmapMatrix : object.__renderTransform;
			var rect = null;
			var colorTransform = (openfl_geom_ColorTransform().default).__pool.get();
			colorTransform.__copyFrom(object.__worldColorTransform);
			if(this.__worldColorTransform != null) {
				colorTransform.__combine(this.__worldColorTransform);
			}
			var needRender = object.__cacheBitmap == null || object.__renderDirty && (force || object.__children != null && object.__children.length > 0) || object.opaqueBackground != object.__cacheBitmapBackground || object.__graphics != null && object.__graphics.__softwareDirty || !object.__cacheBitmapColorTransform.__equals(colorTransform,true);
			if(!needRender && (bitmapMatrix.a != object.__cacheBitmapMatrix.a || bitmapMatrix.b != object.__cacheBitmapMatrix.b || bitmapMatrix.c != object.__cacheBitmapMatrix.c || bitmapMatrix.d != object.__cacheBitmapMatrix.d)) {
				needRender = true;
			}
			if(hasFilters && !needRender) {
				var _g = 0;
				var _g1 = object.__filters;
				while(_g < _g1.length) {
					var filter = _g1[_g];
					++_g;
					if(filter.__renderDirty) {
						needRender = true;
						break;
					}
				}
			}
			if(!needRender && object.__cacheBitmapData != null && object.__cacheBitmapData.image != null && object.__cacheBitmapData.image.version < object.__cacheBitmapData.__textureVersion) {
				needRender = true;
			}
			var updateTransform = needRender || !object.__cacheBitmap.__worldTransform.equals(object.__worldTransform);
			object.__cacheBitmapMatrix.copyFrom(bitmapMatrix);
			object.__cacheBitmapMatrix.tx = 0;
			object.__cacheBitmapMatrix.ty = 0;
			var bitmapWidth = 0;
			var bitmapHeight = 0;
			var filterWidth = 0;
			var filterHeight = 0;
			var offsetX = 0.;
			var offsetY = 0.;
			if(updateTransform) {
				rect = (openfl_geom_Rectangle().default).__pool.get();
				object.__getFilterBounds(rect,object.__cacheBitmapMatrix);
				filterWidth = Math.ceil(rect.width);
				filterHeight = Math.ceil(rect.height);
				if(rect.x > 0) {
					offsetX = Math.ceil(rect.x);
				} else {
					offsetX = Math.floor(rect.x);
				}
				if(rect.y > 0) {
					offsetY = Math.ceil(rect.y);
				} else {
					offsetY = Math.floor(rect.y);
				}
				if(object.__cacheBitmapData != null) {
					if(filterWidth > object.__cacheBitmapData.width || filterHeight > object.__cacheBitmapData.height) {
						bitmapWidth = Math.ceil(Math.max(filterWidth * 1.25,object.__cacheBitmapData.width));
						bitmapHeight = Math.ceil(Math.max(filterHeight * 1.25,object.__cacheBitmapData.height));
						needRender = true;
					} else {
						bitmapWidth = object.__cacheBitmapData.width;
						bitmapHeight = object.__cacheBitmapData.height;
					}
				} else {
					bitmapWidth = filterWidth;
					bitmapHeight = filterHeight;
				}
			}
			if(needRender) {
				object.__cacheBitmapBackground = object.opaqueBackground;
				if(filterWidth >= 0.5 && filterHeight >= 0.5) {
					var needsFill = object.opaqueBackground != null && (bitmapWidth != filterWidth || bitmapHeight != filterHeight);
					var fillColor = object.opaqueBackground != null ? -16777216 | object.opaqueBackground : 0;
					var bitmapColor = needsFill ? 0 : fillColor;
					if(object.__cacheBitmapData == null || bitmapWidth > object.__cacheBitmapData.width || bitmapHeight > object.__cacheBitmapData.height) {
						object.__cacheBitmapData = new (openfl_display_BitmapData().default)(bitmapWidth,bitmapHeight,true,bitmapColor);
						if(object.__cacheBitmap == null) {
							object.__cacheBitmap = new (openfl_display_Bitmap().default)();
						}
						object.__cacheBitmap.__bitmapData = object.__cacheBitmapData;
						object.__cacheBitmapRendererSW = null;
					} else {
						object.__cacheBitmapData.fillRect(object.__cacheBitmapData.rect,bitmapColor);
					}
					if(needsFill) {
						rect.setTo(0,0,filterWidth,filterHeight);
						object.__cacheBitmapData.fillRect(rect,fillColor);
					}
				} else {
					(openfl_geom_ColorTransform().default).__pool.release(colorTransform);
					object.__cacheBitmap = null;
					object.__cacheBitmapData = null;
					object.__cacheBitmapData2 = null;
					object.__cacheBitmapData3 = null;
					object.__cacheBitmapRendererSW = null;
					return true;
				}
			} else {
				object.__cacheBitmapData = object.__cacheBitmap.get_bitmapData();
				object.__cacheBitmapData2 = null;
				object.__cacheBitmapData3 = null;
			}
			if(updateTransform) {
				object.__cacheBitmap.__worldTransform.copyFrom(object.__worldTransform);
				if(bitmapMatrix == object.__renderTransform) {
					object.__cacheBitmap.__renderTransform.identity();
					object.__cacheBitmap.__renderTransform.tx = object.__renderTransform.tx + offsetX;
					object.__cacheBitmap.__renderTransform.ty = object.__renderTransform.ty + offsetY;
				} else {
					object.__cacheBitmap.__renderTransform.copyFrom(object.__cacheBitmapMatrix);
					object.__cacheBitmap.__renderTransform.invert();
					object.__cacheBitmap.__renderTransform.concat(object.__renderTransform);
					object.__cacheBitmap.__renderTransform.tx += offsetX;
					object.__cacheBitmap.__renderTransform.ty += offsetY;
				}
			}
			object.__cacheBitmap.smoothing = this.__allowSmoothing;
			object.__cacheBitmap.__renderable = object.__renderable;
			object.__cacheBitmap.__worldAlpha = object.__worldAlpha;
			object.__cacheBitmap.__worldBlendMode = object.__worldBlendMode;
			object.__cacheBitmap.__worldShader = object.__worldShader;
			object.__cacheBitmap.set_mask(object.__mask);
			if(needRender) {
				if(object.__cacheBitmapRendererSW == null || object.__cacheBitmapRendererSW.__type != "cairo") {
					if(object.__cacheBitmapData.image == null) {
						var color = object.opaqueBackground != null ? -16777216 | object.opaqueBackground : 0;
						object.__cacheBitmapData = new (openfl_display_BitmapData().default)(bitmapWidth,bitmapHeight,true,color);
						object.__cacheBitmap.__bitmapData = object.__cacheBitmapData;
					}
					object.__cacheBitmapRendererSW = new CairoRenderer(new (lime_graphics_cairo_Cairo().default)(object.__cacheBitmapData.getSurface()));
					object.__cacheBitmapRendererSW.__worldTransform = new (openfl_geom_Matrix().default)();
					object.__cacheBitmapRendererSW.__worldColorTransform = new (openfl_geom_ColorTransform().default)();
				}
				if(object.__cacheBitmapColorTransform == null) {
					object.__cacheBitmapColorTransform = new (openfl_geom_ColorTransform().default)();
				}
				object.__cacheBitmapRendererSW.__stage = object.stage;
				object.__cacheBitmapRendererSW.__allowSmoothing = this.__allowSmoothing;
				((js_Boot().default).__cast(object.__cacheBitmapRendererSW , CairoRenderer)).__setBlendMode("normal");
				object.__cacheBitmapRendererSW.__worldAlpha = 1 / object.__worldAlpha;
				object.__cacheBitmapRendererSW.__worldTransform.copyFrom(object.__renderTransform);
				object.__cacheBitmapRendererSW.__worldTransform.invert();
				object.__cacheBitmapRendererSW.__worldTransform.concat(object.__cacheBitmapMatrix);
				object.__cacheBitmapRendererSW.__worldTransform.tx -= offsetX;
				object.__cacheBitmapRendererSW.__worldTransform.ty -= offsetY;
				object.__cacheBitmapRendererSW.__worldColorTransform.__copyFrom(colorTransform);
				object.__cacheBitmapRendererSW.__worldColorTransform.__invert();
				object.__isCacheBitmapRender = true;
				object.__cacheBitmapRendererSW.__drawBitmapData(object.__cacheBitmapData,object,null);
				if(hasFilters) {
					var needSecondBitmapData = false;
					var needCopyOfOriginal = false;
					var _g2 = 0;
					var _g11 = object.__filters;
					while(_g2 < _g11.length) {
						var filter1 = _g11[_g2];
						++_g2;
						if(filter1.__needSecondBitmapData) {
							needSecondBitmapData = true;
						}
						if(filter1.__preserveObject) {
							needCopyOfOriginal = true;
						}
					}
					var bitmap = object.__cacheBitmapData;
					var bitmap2 = null;
					var bitmap3 = null;
					if(needSecondBitmapData) {
						if(object.__cacheBitmapData2 == null || object.__cacheBitmapData2.image == null || bitmapWidth > object.__cacheBitmapData2.width || bitmapHeight > object.__cacheBitmapData2.height) {
							object.__cacheBitmapData2 = new (openfl_display_BitmapData().default)(bitmapWidth,bitmapHeight,true,0);
						} else {
							object.__cacheBitmapData2.fillRect(object.__cacheBitmapData2.rect,0);
						}
						bitmap2 = object.__cacheBitmapData2;
					} else {
						bitmap2 = bitmap;
					}
					if(needCopyOfOriginal) {
						if(object.__cacheBitmapData3 == null || object.__cacheBitmapData3.image == null || bitmapWidth > object.__cacheBitmapData3.width || bitmapHeight > object.__cacheBitmapData3.height) {
							object.__cacheBitmapData3 = new (openfl_display_BitmapData().default)(bitmapWidth,bitmapHeight,true,0);
						} else {
							object.__cacheBitmapData3.fillRect(object.__cacheBitmapData3.rect,0);
						}
						bitmap3 = object.__cacheBitmapData3;
					}
					if(object.__tempPoint == null) {
						object.__tempPoint = new (openfl_geom_Point().default)();
					}
					var destPoint = object.__tempPoint;
					var cacheBitmap;
					var lastBitmap;
					var _g3 = 0;
					var _g12 = object.__filters;
					while(_g3 < _g12.length) {
						var filter2 = _g12[_g3];
						++_g3;
						if(filter2.__preserveObject) {
							bitmap3.copyPixels(bitmap,bitmap.rect,destPoint);
						}
						lastBitmap = filter2.__applyFilter(bitmap2,bitmap,bitmap.rect,destPoint);
						if(filter2.__preserveObject) {
							lastBitmap.draw(bitmap3,null,object.__objectTransform != null ? object.__objectTransform.get_colorTransform() : null);
						}
						filter2.__renderDirty = false;
						if(needSecondBitmapData && lastBitmap == bitmap2) {
							cacheBitmap = bitmap;
							bitmap = bitmap2;
							bitmap2 = cacheBitmap;
						}
					}
					if(object.__cacheBitmapData != bitmap) {
						cacheBitmap = object.__cacheBitmapData;
						object.__cacheBitmapData = bitmap;
						object.__cacheBitmapData2 = cacheBitmap;
						object.__cacheBitmap.__bitmapData = object.__cacheBitmapData;
						object.__cacheBitmapRendererSW = null;
					}
					object.__cacheBitmap.__imageVersion = object.__cacheBitmapData.__textureVersion;
				}
				object.__cacheBitmapColorTransform.__copyFrom(colorTransform);
				if(!object.__cacheBitmapColorTransform.__isDefault(true)) {
					object.__cacheBitmapColorTransform.alphaMultiplier = 1;
					object.__cacheBitmapData.colorTransform(object.__cacheBitmapData.rect,object.__cacheBitmapColorTransform);
				}
				object.__isCacheBitmapRender = false;
			}
			if(updateTransform) {
				(openfl_geom_Rectangle().default).__pool.release(rect);
			}
			updated = updateTransform;
			(openfl_geom_ColorTransform().default).__pool.release(colorTransform);
		} else if(object.__cacheBitmap != null) {
			object.__cacheBitmap = null;
			object.__cacheBitmapData = null;
			object.__cacheBitmapData2 = null;
			object.__cacheBitmapData3 = null;
			object.__cacheBitmapColorTransform = null;
			object.__cacheBitmapRendererSW = null;
			updated = true;
		}
		return updated;
	}
});
CairoRenderer.prototype.__class__ = CairoRenderer.prototype.constructor = $hxClasses["openfl._internal.renderer.cairo.CairoRenderer"] = CairoRenderer;

// Init



// Statics


CairoRenderer.__meta__ = { obj : { SuppressWarnings : ["checkstyle:FieldDocComment"]}}

// Export

exports.default = CairoRenderer;