// Class: openfl._internal.renderer.canvas.CanvasRenderer

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

var $hxClasses = require("./../../../../hxClasses_stub").default;
var $import = require("./../../../../import_stub").default;
var $extend = require("./../../../../extend_stub").default;
function openfl_display_CanvasRenderer() {return require("./../../../../openfl/display/CanvasRenderer");}
function Std() {return require("./../../../../Std");}
function openfl__$internal_renderer_canvas_CanvasBitmap() {return require("./../../../../openfl/_internal/renderer/canvas/CanvasBitmap");}
function openfl__$internal_renderer_canvas_CanvasDisplayObject() {return require("./../../../../openfl/_internal/renderer/canvas/CanvasDisplayObject");}
function lime_graphics_ImageType() {return require("./../../../../lime/graphics/ImageType");}
function lime__$internal_graphics_ImageCanvasUtil() {return require("./../../../../lime/_internal/graphics/ImageCanvasUtil");}
function Type() {return require("./../../../../Type");}
function openfl__$internal_renderer_canvas_CanvasGraphics() {return require("./../../../../openfl/_internal/renderer/canvas/CanvasGraphics");}
function lime_text__$UTF8String_UTF8String_$Impl_$() {return require("./../../../../lime/text/_UTF8String/UTF8String_Impl_");}
function openfl__$internal_formats_html_HTMLParser() {return require("./../../../../openfl/_internal/formats/html/HTMLParser");}
function openfl__$internal_renderer_canvas_CanvasTextField() {return require("./../../../../openfl/_internal/renderer/canvas/CanvasTextField");}
function openfl__$internal_renderer_canvas_CanvasTilemap() {return require("./../../../../openfl/_internal/renderer/canvas/CanvasTilemap");}
function openfl__$internal_renderer_canvas_CanvasVideo() {return require("./../../../../openfl/_internal/renderer/canvas/CanvasVideo");}
function openfl_geom_Matrix() {return require("./../../../../openfl/geom/Matrix");}
function openfl_geom_ColorTransform() {return require("./../../../../openfl/geom/ColorTransform");}
function openfl_geom_Rectangle() {return require("./../../../../openfl/geom/Rectangle");}
function openfl_display_BitmapData() {return require("./../../../../openfl/display/BitmapData");}
function openfl_display_Bitmap() {return require("./../../../../openfl/display/Bitmap");}
function js_Boot() {return require("./../../../../js/Boot");}
function openfl_geom_Point() {return require("./../../../../openfl/geom/Point");}

// Constructor

var CanvasRenderer = function(context) {
	(openfl_display_CanvasRenderer().default).call(this,context);
	this.__colorTransform = new (openfl_geom_ColorTransform().default)();
	this.__transform = new (openfl_geom_Matrix().default)();
	this.__type = "canvas";
}

// Meta

CanvasRenderer.__name__ = ["openfl","_internal","renderer","canvas","CanvasRenderer"];
CanvasRenderer.__super__ = (openfl_display_CanvasRenderer().default);
CanvasRenderer.prototype = $extend((openfl_display_CanvasRenderer().default).prototype, {
	applySmoothing: function(context,value) {
		context.imageSmoothingEnabled = value;
	},
	setTransform: function(transform,context) {
		if(context == null) {
			context = this.context;
		} else if(this.context == context && this.__worldTransform != null) {
			this.__transform.copyFrom(transform);
			this.__transform.concat(this.__worldTransform);
			transform = this.__transform;
		}
		if(this.__roundPixels) {
			context.setTransform(transform.a,transform.b,transform.c,transform.d,(Std().default)["int"](transform.tx),(Std().default)["int"](transform.ty));
		} else {
			context.setTransform(transform.a,transform.b,transform.c,transform.d,transform.tx,transform.ty);
		}
	},
	__clear: function() {
		if(this.__stage != null) {
			var cacheBlendMode = this.__blendMode;
			this.__blendMode = null;
			this.__setBlendMode("normal");
			this.context.setTransform(1,0,0,1,0,0);
			this.context.globalAlpha = 1;
			if(!this.__stage.__transparent && this.__stage.__clearBeforeRender) {
				this.context.fillStyle = this.__stage.__colorString;
				this.context.fillRect(0,0,this.__stage.stageWidth * this.__stage.window.get_scale(),this.__stage.stageHeight * this.__stage.window.get_scale());
			} else if(this.__stage.__transparent && this.__stage.__clearBeforeRender) {
				this.context.clearRect(0,0,this.__stage.stageWidth * this.__stage.window.get_scale(),this.__stage.stageHeight * this.__stage.window.get_scale());
			}
			this.__setBlendMode(cacheBlendMode);
		}
	},
	__drawBitmapData: function(bitmapData,source,clipRect) {
		if(clipRect != null) {
			this.__pushMaskRect(clipRect,source.__renderTransform);
		}
		var buffer = bitmapData.image.buffer;
		if(!this.__allowSmoothing) {
			this.applySmoothing(buffer.__srcContext,false);
		}
		this.__render(source);
		if(!this.__allowSmoothing) {
			this.applySmoothing(buffer.__srcContext,true);
		}
		buffer.__srcContext.setTransform(1,0,0,1,0,0);
		buffer.__srcImageData = null;
		buffer.data = null;
		bitmapData.image.dirty = true;
		bitmapData.image.version++;
		if(clipRect != null) {
			this.__popMaskRect();
		}
	},
	__getAlpha: function(value) {
		return value * this.__worldAlpha;
	},
	__getColorTransform: function(value) {
		if(this.__worldColorTransform != null) {
			this.__colorTransform.__copyFrom(this.__worldColorTransform);
			this.__colorTransform.__combine(value);
			return this.__colorTransform;
		} else {
			return value;
		}
	},
	__popMask: function() {
		this.context.restore();
	},
	__popMaskObject: function(object,handleScrollRect) {
		if(handleScrollRect == null) {
			handleScrollRect = true;
		}
		if(!object.__isCacheBitmapRender && object.__mask != null) {
			this.__popMask();
		}
		if(handleScrollRect && object.__scrollRect != null) {
			this.__popMaskRect();
		}
	},
	__popMaskRect: function() {
		this.context.restore();
	},
	__pushMask: function(mask) {
		this.context.save();
		this.setTransform(mask.__renderTransform,this.context);
		this.context.beginPath();
		this.__renderMask(mask);
		this.context.closePath();
		this.context.clip();
	},
	__pushMaskObject: function(object,handleScrollRect) {
		if(handleScrollRect == null) {
			handleScrollRect = true;
		}
		if(handleScrollRect && object.__scrollRect != null) {
			this.__pushMaskRect(object.__scrollRect,object.__renderTransform);
		}
		if(!object.__isCacheBitmapRender && object.__mask != null) {
			this.__pushMask(object.__mask);
		}
	},
	__pushMaskRect: function(rect,transform) {
		this.context.save();
		this.setTransform(transform,this.context);
		this.context.beginPath();
		this.context.rect(rect.x,rect.y,rect.width,rect.height);
		this.context.clip();
	},
	__render: function(object) {
		if(object != null) {
			if(object.__type != null) {
				this.__renderDisplayObject(object);
			} else {
				this.__renderBitmapData(object);
			}
		}
	},
	__renderBitmap: function(bitmap) {
		this.__updateCacheBitmap(bitmap,false);
		if(bitmap.__bitmapData != null && bitmap.__bitmapData.image != null) {
			bitmap.__imageVersion = bitmap.__bitmapData.image.version;
		}
		if(bitmap.__cacheBitmap != null && !bitmap.__isCacheBitmapRender) {
			(openfl__$internal_renderer_canvas_CanvasBitmap().default).render(bitmap.__cacheBitmap,this);
		} else {
			(openfl__$internal_renderer_canvas_CanvasDisplayObject().default).render(bitmap,this);
			(openfl__$internal_renderer_canvas_CanvasBitmap().default).render(bitmap,this);
		}
	},
	__renderBitmapData: function(bitmapData) {
		if(!bitmapData.readable) {
			return;
		}
		if(bitmapData.image.type == (lime_graphics_ImageType().default).DATA) {
			(lime__$internal_graphics_ImageCanvasUtil().default).convertToCanvas(bitmapData.image);
		}
		this.context.globalAlpha = 1;
		this.setTransform(bitmapData.__renderTransform,this.context);
		this.context.drawImage(bitmapData.image.get_src(),0,0,bitmapData.image.width,bitmapData.image.height);
	},
	__renderDisplayObject: function(object) {
		if(object != null && object.__type != null) {
			var _g = object.__type;
			switch((Type().default).enumIndex(_g)) {
			case 0:
				this.__renderBitmap(object);
				break;
			case 2:
				this.__renderDisplayObjectContainer(object);
				break;
			case 1:case 4:
				this.__renderShape(object);
				break;
			case 5:
				this.__renderSimpleButton(object);
				break;
			case 6:
				this.__renderTextField(object);
				break;
			case 7:
				this.__renderTilemap(object);
				break;
			case 8:
				this.__renderVideo(object);
				break;
			default:
			}
			if(object.__customRenderEvent != null) {
				var event = object.__customRenderEvent;
				event.allowSmoothing = this.__allowSmoothing;
				event.objectMatrix.copyFrom(object.__renderTransform);
				event.objectColorTransform.__copyFrom(object.__worldColorTransform);
				event.renderer = this;
				event.type = "renderCanvas";
				this.__setBlendMode(object.__worldBlendMode);
				this.__pushMaskObject(object);
				object.dispatchEvent(event);
				this.__popMaskObject(object);
			}
		}
	},
	__renderDisplayObjectContainer: function(container) {
		if(this.__domRenderer == null) {
			container.__cleanupRemovedChildren();
		}
		if(!container.__renderable || container.__worldAlpha <= 0 || container.get_mask() != null && (container.get_mask().get_width() <= 0 || container.get_mask().get_height() <= 0)) {
			return;
		}
		this.__updateCacheBitmap(container,false);
		if(container.__cacheBitmap != null && !container.__isCacheBitmapRender) {
			(openfl__$internal_renderer_canvas_CanvasBitmap().default).render(container.__cacheBitmap,this);
		} else {
			(openfl__$internal_renderer_canvas_CanvasDisplayObject().default).render(container,this);
		}
		if(container.__cacheBitmap != null && !container.__isCacheBitmapRender) {
			return;
		}
		this.__pushMaskObject(container);
		if(this.__stage != null) {
			var _g = 0;
			var _g1 = container.__children;
			while(_g < _g1.length) {
				var child = _g1[_g];
				++_g;
				this.__renderDisplayObject(child);
				child.__renderDirty = false;
			}
			container.__renderDirty = false;
		} else {
			var _g2 = 0;
			var _g11 = container.__children;
			while(_g2 < _g11.length) {
				var child1 = _g11[_g2];
				++_g2;
				this.__renderDisplayObject(child1);
			}
		}
		this.__popMaskObject(container);
	},
	__renderMask: function(mask) {
		if(mask != null) {
			var _g = mask.__type;
			switch((Type().default).enumIndex(_g)) {
			case 0:
				this.context.rect(0,0,mask.get_width(),mask.get_height());
				break;
			case 2:
				var container = mask;
				if(this.__domRenderer == null) {
					container.__cleanupRemovedChildren();
				}
				if(container.__graphics != null) {
					(openfl__$internal_renderer_canvas_CanvasGraphics().default).renderMask(container.__graphics,this);
				}
				var _g1 = 0;
				var _g11 = container.__children;
				while(_g1 < _g11.length) {
					var child = _g11[_g1];
					++_g1;
					this.__renderMask(child);
				}
				break;
			case 3:
				break;
			case 5:
				var button = mask;
				this.__renderMask(button.__currentState);
				break;
			default:
				if(mask.__graphics != null) {
					(openfl__$internal_renderer_canvas_CanvasGraphics().default).renderMask(mask.__graphics,this);
				}
			}
		}
	},
	__renderShape: function(shape) {
		if(shape.get_mask() == null || shape.get_mask().get_width() > 0 && shape.get_mask().get_height() > 0) {
			this.__updateCacheBitmap(shape,false);
			if(shape.__cacheBitmap != null && !shape.__isCacheBitmapRender) {
				(openfl__$internal_renderer_canvas_CanvasBitmap().default).render(shape.__cacheBitmap,this);
			} else {
				(openfl__$internal_renderer_canvas_CanvasDisplayObject().default).render(shape,this);
			}
		}
	},
	__renderSimpleButton: function(button) {
		if(!button.__renderable || button.__worldAlpha <= 0 || button.__currentState == null) {
			return;
		}
		this.__pushMaskObject(button);
		this.__renderDisplayObject(button.__currentState);
		this.__popMaskObject(button);
	},
	__renderTextField: function(textField) {
		if(this.__domRenderer != null && !textField.__renderedOnCanvasWhileOnDOM) {
			textField.__renderedOnCanvasWhileOnDOM = true;
			if(textField.get_type() == "input") {
				textField.replaceText(0,(lime_text__$UTF8String_UTF8String_$Impl_$().default).get_length(textField.__text),textField.__text);
			}
			if(textField.__isHTML) {
				textField.__updateText((openfl__$internal_formats_html_HTMLParser().default).parse(textField.__text,textField.__textFormat,textField.__textEngine.textFormatRanges));
			}
			textField.__dirty = true;
			textField.__layoutDirty = true;
			textField.__setRenderDirty();
		}
		if(textField.get_mask() == null || textField.get_mask().get_width() > 0 && textField.get_mask().get_height() > 0) {
			this.__updateCacheBitmap(textField,false);
			if(textField.__cacheBitmap != null && !textField.__isCacheBitmapRender) {
				(openfl__$internal_renderer_canvas_CanvasBitmap().default).render(textField.__cacheBitmap,this);
			} else {
				(openfl__$internal_renderer_canvas_CanvasTextField().default).render(textField,this,textField.__worldTransform);
				var smoothingEnabled = false;
				if(textField.__textEngine.antiAliasType == "advanced" && textField.__textEngine.gridFitType == "pixel") {
					smoothingEnabled = this.context.imageSmoothingEnabled;
					if(smoothingEnabled) {
						this.context.imageSmoothingEnabled = false;
					}
				}
				(openfl__$internal_renderer_canvas_CanvasDisplayObject().default).render(textField,this);
				if(smoothingEnabled) {
					this.context.imageSmoothingEnabled = true;
				}
			}
		}
	},
	__renderTilemap: function(tilemap) {
		this.__updateCacheBitmap(tilemap,false);
		if(tilemap.__cacheBitmap != null && !tilemap.__isCacheBitmapRender) {
			(openfl__$internal_renderer_canvas_CanvasBitmap().default).render(tilemap.__cacheBitmap,this);
		} else {
			(openfl__$internal_renderer_canvas_CanvasDisplayObject().default).render(tilemap,this);
			(openfl__$internal_renderer_canvas_CanvasTilemap().default).render(tilemap,this);
		}
	},
	__renderVideo: function(video) {
		(openfl__$internal_renderer_canvas_CanvasVideo().default).render(video,this);
	},
	__setBlendMode: function(value) {
		if(this.__overrideBlendMode != null) {
			value = this.__overrideBlendMode;
		}
		if(this.__blendMode == value) {
			return;
		}
		this.__blendMode = value;
		this.__setBlendModeContext(this.context,value);
	},
	__setBlendModeContext: function(context,value) {
		switch(value) {
		case "add":
			context.globalCompositeOperation = "lighter";
			break;
		case "darken":
			context.globalCompositeOperation = "darken";
			break;
		case "difference":
			context.globalCompositeOperation = "difference";
			break;
		case "hardlight":
			context.globalCompositeOperation = "hard-light";
			break;
		case "lighten":
			context.globalCompositeOperation = "lighten";
			break;
		case "multiply":
			context.globalCompositeOperation = "multiply";
			break;
		case "overlay":
			context.globalCompositeOperation = "overlay";
			break;
		case "screen":
			context.globalCompositeOperation = "screen";
			break;
		default:
			context.globalCompositeOperation = "source-over";
		}
	},
	__updateCacheBitmap: function(object,force) {
		if(object.__isCacheBitmapRender) {
			return false;
		}
		var updated = false;
		if(object.get_cacheAsBitmap() || !object.__worldColorTransform.__isDefault(true) || this.__worldColorTransform != null && !this.__worldColorTransform.__isDefault(true)) {
			if(object.__cacheBitmapMatrix == null) {
				object.__cacheBitmapMatrix = new (openfl_geom_Matrix().default)();
			}
			var hasFilters = object.__filters != null;
			var bitmapMatrix = object.__cacheAsBitmapMatrix != null ? object.__cacheAsBitmapMatrix : object.__renderTransform;
			var rect = null;
			var colorTransform = (openfl_geom_ColorTransform().default).__pool.get();
			colorTransform.__copyFrom(object.__worldColorTransform);
			if(this.__worldColorTransform != null) {
				colorTransform.__combine(this.__worldColorTransform);
			}
			var needRender = object.__cacheBitmap == null || object.__renderDirty && (force || object.__children != null && object.__children.length > 0) || object.opaqueBackground != object.__cacheBitmapBackground || object.__graphics != null && object.__graphics.__softwareDirty || !object.__cacheBitmapColorTransform.__equals(colorTransform,true);
			if(!needRender && (bitmapMatrix.a != object.__cacheBitmapMatrix.a || bitmapMatrix.b != object.__cacheBitmapMatrix.b || bitmapMatrix.c != object.__cacheBitmapMatrix.c || bitmapMatrix.d != object.__cacheBitmapMatrix.d)) {
				needRender = true;
			}
			if(hasFilters && !needRender) {
				var _g = 0;
				var _g1 = object.__filters;
				while(_g < _g1.length) {
					var filter = _g1[_g];
					++_g;
					if(filter.__renderDirty) {
						needRender = true;
						break;
					}
				}
			}
			if(!needRender && object.__cacheBitmapData != null && object.__cacheBitmapData.image != null && object.__cacheBitmapData.image.version < object.__cacheBitmapData.__textureVersion) {
				needRender = true;
			}
			var updateTransform = needRender || !object.__cacheBitmap.__worldTransform.equals(object.__worldTransform);
			object.__cacheBitmapMatrix.copyFrom(bitmapMatrix);
			object.__cacheBitmapMatrix.tx = 0;
			object.__cacheBitmapMatrix.ty = 0;
			var bitmapWidth = 0;
			var bitmapHeight = 0;
			var filterWidth = 0;
			var filterHeight = 0;
			var offsetX = 0.;
			var offsetY = 0.;
			if(updateTransform) {
				rect = (openfl_geom_Rectangle().default).__pool.get();
				object.__getFilterBounds(rect,object.__cacheBitmapMatrix);
				filterWidth = Math.ceil(rect.width);
				filterHeight = Math.ceil(rect.height);
				if(rect.x > 0) {
					offsetX = Math.ceil(rect.x);
				} else {
					offsetX = Math.floor(rect.x);
				}
				if(rect.y > 0) {
					offsetY = Math.ceil(rect.y);
				} else {
					offsetY = Math.floor(rect.y);
				}
				if(object.__cacheBitmapData != null) {
					if(filterWidth > object.__cacheBitmapData.width || filterHeight > object.__cacheBitmapData.height) {
						bitmapWidth = Math.ceil(Math.max(filterWidth * 1.25,object.__cacheBitmapData.width));
						bitmapHeight = Math.ceil(Math.max(filterHeight * 1.25,object.__cacheBitmapData.height));
						needRender = true;
					} else {
						bitmapWidth = object.__cacheBitmapData.width;
						bitmapHeight = object.__cacheBitmapData.height;
					}
				} else {
					bitmapWidth = filterWidth;
					bitmapHeight = filterHeight;
				}
			}
			if(needRender) {
				object.__cacheBitmapBackground = object.opaqueBackground;
				if(filterWidth >= 0.5 && filterHeight >= 0.5) {
					var needsFill = object.opaqueBackground != null && (bitmapWidth != filterWidth || bitmapHeight != filterHeight);
					var fillColor = object.opaqueBackground != null ? -16777216 | object.opaqueBackground : 0;
					var bitmapColor = needsFill ? 0 : fillColor;
					if(object.__cacheBitmapData == null || bitmapWidth > object.__cacheBitmapData.width || bitmapHeight > object.__cacheBitmapData.height) {
						object.__cacheBitmapData = new (openfl_display_BitmapData().default)(bitmapWidth,bitmapHeight,true,bitmapColor);
						if(object.__cacheBitmap == null) {
							object.__cacheBitmap = new (openfl_display_Bitmap().default)();
						}
						object.__cacheBitmap.__bitmapData = object.__cacheBitmapData;
						object.__cacheBitmapRendererSW = null;
					} else {
						object.__cacheBitmapData.fillRect(object.__cacheBitmapData.rect,bitmapColor);
					}
					if(needsFill) {
						rect.setTo(0,0,filterWidth,filterHeight);
						object.__cacheBitmapData.fillRect(rect,fillColor);
					}
				} else {
					(openfl_geom_ColorTransform().default).__pool.release(colorTransform);
					if(this.__domRenderer != null && object.__cacheBitmap != null) {
						this.__domRenderer.__clearBitmap(object.__cacheBitmap);
					}
					object.__cacheBitmap = null;
					object.__cacheBitmapData = null;
					object.__cacheBitmapData2 = null;
					object.__cacheBitmapData3 = null;
					object.__cacheBitmapRendererSW = null;
					return true;
				}
			} else {
				object.__cacheBitmapData = object.__cacheBitmap.get_bitmapData();
				object.__cacheBitmapData2 = null;
				object.__cacheBitmapData3 = null;
			}
			if(updateTransform) {
				object.__cacheBitmap.__worldTransform.copyFrom(object.__worldTransform);
				if(bitmapMatrix == object.__renderTransform) {
					object.__cacheBitmap.__renderTransform.identity();
					object.__cacheBitmap.__renderTransform.tx = object.__renderTransform.tx + offsetX;
					object.__cacheBitmap.__renderTransform.ty = object.__renderTransform.ty + offsetY;
				} else {
					object.__cacheBitmap.__renderTransform.copyFrom(object.__cacheBitmapMatrix);
					object.__cacheBitmap.__renderTransform.invert();
					object.__cacheBitmap.__renderTransform.concat(object.__renderTransform);
					object.__cacheBitmap.__renderTransform.tx += offsetX;
					object.__cacheBitmap.__renderTransform.ty += offsetY;
				}
			}
			object.__cacheBitmap.smoothing = this.__allowSmoothing;
			object.__cacheBitmap.__renderable = object.__renderable;
			object.__cacheBitmap.__worldAlpha = object.__worldAlpha;
			object.__cacheBitmap.__worldBlendMode = object.__worldBlendMode;
			object.__cacheBitmap.__worldShader = object.__worldShader;
			object.__cacheBitmap.set_mask(object.__mask);
			if(needRender) {
				if(object.__cacheBitmapRendererSW == null || object.__cacheBitmapRendererSW.__type != "canvas") {
					if(object.__cacheBitmapData.image == null) {
						var color = object.opaqueBackground != null ? -16777216 | object.opaqueBackground : 0;
						object.__cacheBitmapData = new (openfl_display_BitmapData().default)(bitmapWidth,bitmapHeight,true,color);
						object.__cacheBitmap.__bitmapData = object.__cacheBitmapData;
					}
					(lime__$internal_graphics_ImageCanvasUtil().default).convertToCanvas(object.__cacheBitmapData.image);
					object.__cacheBitmapRendererSW = new CanvasRenderer(object.__cacheBitmapData.image.buffer.__srcContext);
					object.__cacheBitmapRendererSW.__worldTransform = new (openfl_geom_Matrix().default)();
					object.__cacheBitmapRendererSW.__worldColorTransform = new (openfl_geom_ColorTransform().default)();
				}
				if(object.__cacheBitmapColorTransform == null) {
					object.__cacheBitmapColorTransform = new (openfl_geom_ColorTransform().default)();
				}
				object.__cacheBitmapRendererSW.__stage = object.stage;
				object.__cacheBitmapRendererSW.__allowSmoothing = this.__allowSmoothing;
				((js_Boot().default).__cast(object.__cacheBitmapRendererSW , CanvasRenderer)).__setBlendMode("normal");
				object.__cacheBitmapRendererSW.__worldAlpha = 1 / object.__worldAlpha;
				object.__cacheBitmapRendererSW.__worldTransform.copyFrom(object.__renderTransform);
				object.__cacheBitmapRendererSW.__worldTransform.invert();
				object.__cacheBitmapRendererSW.__worldTransform.concat(object.__cacheBitmapMatrix);
				object.__cacheBitmapRendererSW.__worldTransform.tx -= offsetX;
				object.__cacheBitmapRendererSW.__worldTransform.ty -= offsetY;
				object.__cacheBitmapRendererSW.__worldColorTransform.__copyFrom(colorTransform);
				object.__cacheBitmapRendererSW.__worldColorTransform.__invert();
				object.__isCacheBitmapRender = true;
				object.__cacheBitmapRendererSW.__drawBitmapData(object.__cacheBitmapData,object,null);
				if(hasFilters) {
					var needSecondBitmapData = false;
					var needCopyOfOriginal = false;
					var _g2 = 0;
					var _g11 = object.__filters;
					while(_g2 < _g11.length) {
						var filter1 = _g11[_g2];
						++_g2;
						if(filter1.__needSecondBitmapData) {
							needSecondBitmapData = true;
						}
						if(filter1.__preserveObject) {
							needCopyOfOriginal = true;
						}
					}
					var bitmap = object.__cacheBitmapData;
					var bitmap2 = null;
					var bitmap3 = null;
					if(needSecondBitmapData) {
						if(object.__cacheBitmapData2 == null || object.__cacheBitmapData2.image == null || bitmapWidth > object.__cacheBitmapData2.width || bitmapHeight > object.__cacheBitmapData2.height) {
							object.__cacheBitmapData2 = new (openfl_display_BitmapData().default)(bitmapWidth,bitmapHeight,true,0);
						} else {
							object.__cacheBitmapData2.fillRect(object.__cacheBitmapData2.rect,0);
						}
						bitmap2 = object.__cacheBitmapData2;
					} else {
						bitmap2 = bitmap;
					}
					if(needCopyOfOriginal) {
						if(object.__cacheBitmapData3 == null || object.__cacheBitmapData3.image == null || bitmapWidth > object.__cacheBitmapData3.width || bitmapHeight > object.__cacheBitmapData3.height) {
							object.__cacheBitmapData3 = new (openfl_display_BitmapData().default)(bitmapWidth,bitmapHeight,true,0);
						} else {
							object.__cacheBitmapData3.fillRect(object.__cacheBitmapData3.rect,0);
						}
						bitmap3 = object.__cacheBitmapData3;
					}
					if(object.__tempPoint == null) {
						object.__tempPoint = new (openfl_geom_Point().default)();
					}
					var destPoint = object.__tempPoint;
					var cacheBitmap;
					var lastBitmap;
					var _g3 = 0;
					var _g12 = object.__filters;
					while(_g3 < _g12.length) {
						var filter2 = _g12[_g3];
						++_g3;
						if(filter2.__preserveObject) {
							bitmap3.copyPixels(bitmap,bitmap.rect,destPoint);
						}
						lastBitmap = filter2.__applyFilter(bitmap2,bitmap,bitmap.rect,destPoint);
						if(filter2.__preserveObject) {
							lastBitmap.draw(bitmap3,null,object.__objectTransform != null ? object.__objectTransform.get_colorTransform() : null);
						}
						filter2.__renderDirty = false;
						if(needSecondBitmapData && lastBitmap == bitmap2) {
							cacheBitmap = bitmap;
							bitmap = bitmap2;
							bitmap2 = cacheBitmap;
						}
					}
					if(object.__cacheBitmapData != bitmap) {
						cacheBitmap = object.__cacheBitmapData;
						object.__cacheBitmapData = bitmap;
						object.__cacheBitmapData2 = cacheBitmap;
						object.__cacheBitmap.__bitmapData = object.__cacheBitmapData;
						object.__cacheBitmapRendererSW = null;
					}
					object.__cacheBitmap.__imageVersion = object.__cacheBitmapData.__textureVersion;
				}
				object.__cacheBitmapColorTransform.__copyFrom(colorTransform);
				if(!object.__cacheBitmapColorTransform.__isDefault(true)) {
					object.__cacheBitmapColorTransform.alphaMultiplier = 1;
					object.__cacheBitmapData.colorTransform(object.__cacheBitmapData.rect,object.__cacheBitmapColorTransform);
				}
				object.__isCacheBitmapRender = false;
			}
			if(updateTransform) {
				(openfl_geom_Rectangle().default).__pool.release(rect);
			}
			updated = updateTransform;
			(openfl_geom_ColorTransform().default).__pool.release(colorTransform);
		} else if(object.__cacheBitmap != null) {
			if(this.__domRenderer != null && object.__cacheBitmap != null) {
				this.__domRenderer.__clearBitmap(object.__cacheBitmap);
			}
			object.__cacheBitmap = null;
			object.__cacheBitmapData = null;
			object.__cacheBitmapData2 = null;
			object.__cacheBitmapData3 = null;
			object.__cacheBitmapColorTransform = null;
			object.__cacheBitmapRendererSW = null;
			updated = true;
		}
		return updated;
	}
});
CanvasRenderer.prototype.__class__ = CanvasRenderer.prototype.constructor = $hxClasses["openfl._internal.renderer.canvas.CanvasRenderer"] = CanvasRenderer;

// Init



// Statics


CanvasRenderer.__meta__ = { obj : { SuppressWarnings : ["checkstyle:FieldDocComment"]}}

// Export

exports.default = CanvasRenderer;