// Class: openfl._internal.renderer.context3D.Context3DBitmap

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

var $hxClasses = require("./../../../../hxClasses_stub").default;
var $import = require("./../../../../import_stub").default;
function openfl__$internal_renderer_DisplayObjectType() {return require("./../../../../openfl/_internal/renderer/DisplayObjectType");}
function openfl_geom_Matrix() {return require("./../../../../openfl/geom/Matrix");}
function openfl__$internal_renderer_context3D_Context3DMaskShader() {return require("./../../../../openfl/_internal/renderer/context3D/Context3DMaskShader");}

// Constructor

var Context3DBitmap = function(){}

// Meta

Context3DBitmap.__name__ = ["openfl","_internal","renderer","context3D","Context3DBitmap"];
Context3DBitmap.prototype = {
	
};
Context3DBitmap.prototype.__class__ = Context3DBitmap.prototype.constructor = $hxClasses["openfl._internal.renderer.context3D.Context3DBitmap"] = Context3DBitmap;

// Init



// Statics

Context3DBitmap.render = function(bitmap,renderer) {
	if(!bitmap.__renderable || bitmap.__worldAlpha <= 0) {
		return;
	}
	if(bitmap.__bitmapData != null && bitmap.__bitmapData.__isValid) {
		var context = renderer.context3D;
		var alphaMask = bitmap.get_mask() != null && bitmap.get_mask().get_cacheAsBitmap();
		if(alphaMask && bitmap.get_mask().__type != (openfl__$internal_renderer_DisplayObjectType().default).BITMAP) {
			alphaMask = false;
		}
		renderer.__setBlendMode(bitmap.__worldBlendMode);
		if(!alphaMask) {
			renderer.__pushMaskObject(bitmap);
		}
		var shader = renderer.__initDisplayShader(!alphaMask ? bitmap.__worldShader : renderer.__alphaMaskShader);
		renderer.setShader(shader);
		renderer.applyBitmapData(bitmap.__bitmapData,renderer.__allowSmoothing && (bitmap.smoothing || renderer.__upscaled));
		renderer.applyMatrix(renderer.__getMatrix(bitmap.__renderTransform,bitmap.pixelSnapping));
		renderer.applyAlpha(bitmap.__worldAlpha);
		renderer.applyColorTransform(bitmap.__worldColorTransform);
		if(alphaMask) {
			var maskBitmap = bitmap.get_mask();
			renderer.__currentShader.__alphaTexture.input = maskBitmap.__bitmapData;
			if(renderer.__currentShader.__alphaTextureMatrix.value == null) {
				renderer.__currentShader.__alphaTextureMatrix.value = [];
			}
			var matrix = renderer.__currentShader.__alphaTextureMatrix.value;
			var transform = (openfl_geom_Matrix().default).__pool.get();
			transform.copyFrom(bitmap.__renderTransform);
			transform.invert();
			transform.concat(maskBitmap.__renderTransform);
			matrix[0] = transform.a * (bitmap.__bitmapData.width / maskBitmap.__bitmapData.width);
			matrix[1] = transform.b;
			matrix[4] = transform.c;
			matrix[5] = transform.d * (bitmap.__bitmapData.height / maskBitmap.__bitmapData.height);
			matrix[12] = transform.tx;
			matrix[13] = transform.ty;
			matrix[15] = 0.0;
			(openfl_geom_Matrix().default).__pool.release(transform);
		}
		renderer.updateShader();
		var vertexBuffer = bitmap.__bitmapData.getVertexBuffer(context);
		if(shader.__position != null) {
			context.setVertexBufferAt(shader.__position.index,vertexBuffer,0,"float3");
		}
		if(shader.__textureCoord != null) {
			context.setVertexBufferAt(shader.__textureCoord.index,vertexBuffer,3,"float2");
		}
		var indexBuffer = bitmap.__bitmapData.getIndexBuffer(context);
		context.drawTriangles(indexBuffer);
		renderer.__clearShader();
		if(!alphaMask) {
			renderer.__popMaskObject(bitmap);
		}
	}
}
Context3DBitmap.renderMask = function(bitmap,renderer) {
	if(bitmap.__bitmapData != null && bitmap.__bitmapData.__isValid) {
		var context = renderer.context3D;
		var shader = renderer.__maskShader;
		renderer.setShader(shader);
		renderer.applyBitmapData((openfl__$internal_renderer_context3D_Context3DMaskShader().default).opaqueBitmapData,true);
		renderer.applyMatrix(renderer.__getMatrix(bitmap.__renderTransform,bitmap.pixelSnapping));
		renderer.updateShader();
		var vertexBuffer = bitmap.__bitmapData.getVertexBuffer(context);
		if(shader.__position != null) {
			context.setVertexBufferAt(shader.__position.index,vertexBuffer,0,"float3");
		}
		if(shader.__textureCoord != null) {
			context.setVertexBufferAt(shader.__textureCoord.index,vertexBuffer,3,"float2");
		}
		var indexBuffer = bitmap.__bitmapData.getIndexBuffer(context);
		context.drawTriangles(indexBuffer);
		renderer.__clearShader();
	}
}
Context3DBitmap.__meta__ = { obj : { SuppressWarnings : ["checkstyle:FieldDocComment"]}}

// Export

exports.default = Context3DBitmap;